/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jogo;

import java.awt.Graphics2D;
import java.awt.Image;

/**
 *
 * @author carlos
 */
public class Bomba extends Elemento {

     private int posYBomb;
     private int posXBomb;
     private int deslocamentoPixel;
     private boolean bombaViva; //booleano indicador de bomba ativa (viva)
     private boolean explodindo; //booleano indicador de bomba explodindo
     private boolean explodida; //booleano indicador de bomba já explodida
     private int tempoDeVida; //inteiro determinador do tempo de vida da bomba ativa
     private int tempoDeExplosao; //inteiro determinador do tempo de explosão da bomba
     private Image bomba; // imagem da bomba
     private Image explosao; // imagem da explosao
     private Image tijoloQuebrado; 
     Jogador jogador; //referencia de qual jogador lançou a bomba
     Jogador outroJogador; //referencia ao outro jogador
     
     //Variáveis responsáveis por guardar e contar blocos na explosão
     private boolean marcadorDir; //marca quando deve para de contar espaços
     private int indTijoloDir; // indica o primeiro tijolo a ser alcançado pela bomba na direção direita
     private int contLivresDir;// indica quantidade de espaços vagos a direita para imprimir a explosão
     private boolean explodiuDir;// indica se as contagens do lado direito já foram feitas
     private boolean marcadorEsq; //marca quando deve para de contar espaços
     private int indTijoloEsq; // indica o primeiro tijolo a ser alcançado pela bomba na direção esquerda
     private int contLivresEsq;// indica quantidade de espaços vagos para imprimir a explosão
     private boolean explodiuEsq; // indica se as contagens do lado esquerdo já foram feitas
     private boolean marcadorCima; //marca quando deve para de contar espaços
     private int indTijoloCima; // indica o primeiro tijolo a ser alcançado pela bomba na direção cima
     private int contLivresCima;// indica quantidade de espaços vagos para imprimir a explosão
     private boolean explodiuCima; // indica se as contagens de cima já foram feitas
     private boolean marcadorBaixo; //marca quando deve para de contar espaços
     private int indTijoloBaixo; // indica o primeiro tijolo a ser alcançado pela bomba na direção baixo
     private int contLivresBaixo;// indica quantidade de espaços vagos para imprimir a explosão
     private boolean explodiuBaixo;// indica se as contagens de baixo já foram feitas
     private boolean jogadorPerdeuVida;// indica se o jogador já foi morto por esta bomba. Sem esta variável o jogador ia morrer várias vezes pela mesma bomba de acordo com a taxa de atualização do jogo
     private boolean outroJogadorPerdeuVida;// indica se o outro jogador já foi morto por esta bomba. Sem esta variável o jogador ia morrer várias vezes pela mesma bomba de acordo com a taxa de atualização do jogo

     public Bomba(JogoTimer p, String imagemNome, int mx, int my, Jogador j, Jogador jj) {
          super(p, imagemNome, mx, my);
          this.bomba = this.carregarImagem(this.imagemNome);
          this.explosao = this.carregarImagem("explosao.png");
          this.tijoloQuebrado = this.carregarImagem("tijolo_quebrado.png");
          this.bombaViva = false; //indica que a bomba esta no cenário porém ainda não explodiu
          this.tempoDeVida = 0;
          this.explodindo = false; //indica que a bomba está em processo de explosão (desenho das imagens de explosão)
          this.explodida = false; //indica que a bomba já foi explodida e está pronta para ser retirada do array de bombas
          this.tempoDeExplosao = 0;
          this.posYBomb = this.matLinha;
          this.posXBomb = this.matColuna;
          this.jogador = j; //referencia ao jogador que lançou a bomba
          this.outroJogador = jj; //referencia ao outro jogador ativo
          this.acionarBomba(); // inicia a bomba ao ser criada
          this.deslocamentoPixel = 40; // para desenhar drawImage (coluna e linha)
     }

     @Override
     public synchronized void atualizar() {
     }

     /**
      * Desenha a imagem no contexto gráfico do Pai. Contém o algorítimo de realizar todo o funcionamento de uma bomba (bomba ativa(viva), explodindo e finalização da bomba)
      * @param g
      */
     @Override
     public synchronized void  desenhar(Graphics2D g) {
          // Se bomba está viva
          if (this.bombaViva) {
               // E tempo de vida maior que 0
               if (this.tempoDeVida > 0) {
                    g.drawImage(this.bomba, this.posXBomb, this.posYBomb, this.jogo); //enquanto não esgotar o tempo de vida da bomba, imprime na tela a imagem de uma bomba
                    this.tempoDeVida = this.tempoDeVida - 10;
               } else {
                    this.explodindoBomba(); //quando esgota o tempo de vida, inicia-se o processo de explosão (bomba ainda não finaliza)
               }
          }
          // Processo de explosão da bomba. Por enquanto não é feito a imagem da explosão da bomba nos blocos adjacentes, somente é feito a contagem de blocos livres ou tijolos/metal para todas as direções.
          if (this.explodindo) {
               if (this.tempoDeExplosao > 0) {
                    g.drawImage(this.explosao, this.posXBomb, this.posYBomb, this.jogo); //enquanto não esgotar o tempo de explosão da bomba, imprime na tela a imagem de uma explosão no lugar da mesma
                    this.tempoDeExplosao = this.tempoDeExplosao - 10;

                    //O algorítimo a seguir faz toda a contagem de espaços livres ou não, em todas as direções, para em seguida realizar a impressão das explosões na tela.
                    //Contagem do lado direito
                    if (this.explodiuDir == false) {
                         for (int i = 1; i <= this.jogador.getRaioExplosao(); i++) {
                              if (marcadorDir != true) {
                                   //Enquanto não atingir o limite do raio da explosão ou algum tijolo.
                                   if (jogo.estaLivre(posYBomb / 40, posXBomb / 40 + i)) {
                                        this.contLivresDir++; //Adiciona a variável quantos blocos livres contém a direita da bomba
                                   } else {
                                        // Se alcançou algum tijolo, põe na variável "indTijolo" a posição do tijolo a partir da bomba (n de blocos) e marca o indicador para não repetir este código, pois explosão já alcançou seu máximo.
                                        this.marcadorDir = true;
                                        this.indTijoloDir = i;
                                   }
                              }
                         }
                         // Se já alcançou tanto o limite do raio da explosão ou o alcance de um tijolo ou bloco não destrutível marca esta variável para sair do laço das contagens do lado direito
                         this.explodiuDir = true;
                    }
                    //Mesmo processo porém para o lado esquerdo
                    if (this.explodiuEsq == false) {
                         for (int i = 1; i <= this.jogador.getRaioExplosao(); i++) {
                              if (marcadorEsq != true) {
                                   if (jogo.estaLivre(posYBomb / 40, posXBomb / 40 - i)) {
                                        this.contLivresEsq++;
                                   } else {
                                        this.marcadorEsq = true;
                                        this.indTijoloEsq = i;
                                   }
                              }
                         }
                         this.explodiuEsq = true;
                    }
                    //Mesmo processo porém para a direção acima
                    if (this.explodiuCima == false) {
                         for (int i = 1; i <= this.jogador.getRaioExplosao(); i++) {
                              if (marcadorCima != true) {
                                   if (jogo.estaLivre(posYBomb / 40 - i, posXBomb / 40)) {
                                        this.contLivresCima++;
                                   } else {
                                        this.marcadorCima = true;
                                        this.indTijoloCima = i;
                                   }
                              }
                         }
                         this.explodiuCima = true;
                    }
                    //Mesmo processo porém para a direção abaixo
                    if (this.explodiuBaixo == false) {
                         for (int i = 1; i <= this.jogador.getRaioExplosao(); i++) {
                              if (marcadorBaixo != true) {
                                   if (jogo.estaLivre(posYBomb / 40 + i, posXBomb / 40)) {
                                        this.contLivresBaixo++;
                                   } else {
                                        this.marcadorBaixo = true;
                                        this.indTijoloBaixo = i;
                                   }
                              }
                         }
                         this.explodiuBaixo = true;
                    }
               //Finaliza a bomba após esgotar o tempo de explosão
               } else {
                    this.finalizandoBomba();
               }

               // Aqui imprime na tela as explosões após já ter feito a contagem de blocos implementados no algoritimo acima e verifica se jogadores estão no raio de explosão
               //Lado direito
               for (int i = 1; i <= contLivresDir; i++) {
                    //Inicia-se a imagem da explosão na quantidade estipulada na variável "contLivres".
                    g.drawImage(this.explosao, this.posXBomb + this.deslocamentoPixel * i, this.posYBomb, this.jogo);

                    if (this.jogadorPerdeuVida == false) {
                         if (this.jogadorPos(posXBomb / 40 + i, posYBomb / 40) || this.jogadorPos(posXBomb / 40, posYBomb / 40)) { //Se o jogador estiver no raio de explosão da bomba, o mesmo perde uma vida
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.jogador);
                              this.jogador.jogadorPerdeuVida(this.jogador);
                              this.jogadorPerdeuVida = true; //Indica que este jogador perdeu uma vida para esta bomba.
                         }
                    }
                    if (this.outroJogadorPerdeuVida == false) {
                         if (this.outroJogadorPos(posXBomb / 40 + i, posYBomb / 40) || this.outroJogadorPos(posXBomb / 40, posYBomb / 40)) { //Se o outro jogador estiver no raio de explosão da bomba, o mesmo perde uma vida
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.outroJogador);
                              this.outroJogador.jogadorPerdeuVida(this.outroJogador);
                              this.outroJogadorPerdeuVida = true; //Indica que este jogador perdeu uma vida para esta bomba.
                         }
                    }

               }
               //Lado esquedo
               for (int i = 1; i <= contLivresEsq; i++) {
                    g.drawImage(this.explosao, this.posXBomb - this.deslocamentoPixel * i, this.posYBomb, this.jogo);
                    if (this.jogadorPerdeuVida == false) {
                         if (this.jogadorPos(posXBomb / 40 - i, posYBomb / 40) || this.jogadorPos(posXBomb / 40, posYBomb / 40)) {
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.jogador);
                              this.jogador.jogadorPerdeuVida(this.jogador);
                              this.jogadorPerdeuVida = true;
                         }
                    }
                    if (this.outroJogadorPerdeuVida == false) {
                         if (this.outroJogadorPos(posXBomb / 40 - i, posYBomb / 40) || this.outroJogadorPos(posXBomb / 40, posYBomb / 40)) {
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.outroJogador);
                              this.outroJogador.jogadorPerdeuVida(this.outroJogador);
                              this.outroJogadorPerdeuVida = true;
                         }
                    }
               }
               //Cima
               for (int i = 1; i <= contLivresCima; i++) {
                    g.drawImage(this.explosao, this.posXBomb, this.posYBomb - this.deslocamentoPixel * i, this.jogo);
                    if (this.jogadorPerdeuVida == false) {
                         if (this.jogadorPos(posXBomb / 40, posYBomb / 40 - i) || this.jogadorPos(posXBomb / 40, posYBomb / 40)) {
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.jogador);
                              this.jogador.jogadorPerdeuVida(this.jogador);
                              this.jogadorPerdeuVida = true;
                         }
                    }
                    if (this.outroJogadorPerdeuVida == false) {
                         if (this.outroJogadorPos(posXBomb / 40, posYBomb / 40 - i) || this.outroJogadorPos(posXBomb / 40, posYBomb / 40)) {
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.outroJogador);
                              this.outroJogador.jogadorPerdeuVida(this.outroJogador);
                              this.outroJogadorPerdeuVida = true;
                         }
                    }
               }
               //Baixo
               for (int i = 1; i <= contLivresBaixo; i++) {
                    g.drawImage(this.explosao, this.posXBomb, this.posYBomb + this.deslocamentoPixel * i, this.jogo);
                    if (this.jogadorPerdeuVida == false) {
                         if (this.jogadorPos(posXBomb / 40, posYBomb / 40 + i) || this.jogadorPos(posXBomb / 40, posYBomb / 40)) {
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.jogador);
                              this.jogador.jogadorPerdeuVida(this.jogador);
                              this.jogadorPerdeuVida = true;
                         }
                    }
                    if (this.outroJogadorPerdeuVida == false) {
                         if (this.outroJogadorPos(posXBomb / 40, posYBomb / 40 + i) || this.outroJogadorPos(posXBomb / 40, posYBomb / 40)) {
                              this.jogo.escreverNoStatus("Perdeu 1 vida!",this.outroJogador);
                              this.outroJogador.jogadorPerdeuVida(this.outroJogador);
                              this.outroJogadorPerdeuVida = true;
                         }
                    }
               }

               // Algoritimo a seguir faz o processo de destruição do bloco de tijolo no local indicado pela variável indTijolo. Todas as direções

               if (this.jogo.isTijolo(posYBomb / 40, posXBomb / 40 + this.indTijoloDir)) {
                    g.drawImage(this.tijoloQuebrado, this.posXBomb + this.deslocamentoPixel * indTijoloDir, this.posYBomb, this.jogo);
                    this.jogo.explodeTijolo(posYBomb / 40, posXBomb / 40 + this.indTijoloDir);
               }
               if (this.jogo.isTijolo(posYBomb / 40, posXBomb / 40 - this.indTijoloEsq)) {
                    g.drawImage(this.tijoloQuebrado, this.posXBomb - this.deslocamentoPixel * indTijoloEsq, this.posYBomb, this.jogo);
                    this.jogo.explodeTijolo(posYBomb / 40, posXBomb / 40 - this.indTijoloEsq);
               }
               if (this.jogo.isTijolo(posYBomb / 40 - this.indTijoloCima, posXBomb / 40)) {
                    g.drawImage(this.tijoloQuebrado, this.posXBomb, this.posYBomb - this.deslocamentoPixel * indTijoloCima, this.jogo);
                    this.jogo.explodeTijolo(posYBomb / 40 - this.indTijoloCima, posXBomb / 40);
               }
               if (this.jogo.isTijolo(posYBomb / 40 + this.indTijoloBaixo, posXBomb / 40)) {
                    g.drawImage(this.tijoloQuebrado, this.posXBomb, this.posYBomb + this.deslocamentoPixel * indTijoloBaixo, this.jogo);
                    this.jogo.explodeTijolo(posYBomb / 40 + this.indTijoloBaixo, posXBomb / 40);
               }

          }
     }

     /**
      * Método responsável por ativar a bomba no cenário. Utilizado quando o jogador aperta o comando de soltar bomba
      */
     public synchronized void acionarBomba() {
          this.jogador.setBombasSimultaneas(this.jogador.getBombasSimultaneas() - 1); //Reduz 1 das bombas simultâneas do jogador que a lançou
          this.bombaViva = true;
          this.explodindo = false;
          tempoDeVida = this.velocidade * 6; //Define o tempo de vida da bomba na tela

     }
     /**
      * //Método responsável por explodir a bomba após o término do tempo de vida
      */
     public synchronized void explodindoBomba() {
          this.bombaViva = false;
          this.explodindo = true;
          tempoDeExplosao = this.velocidade * 2; //Define o tempo de explosão da bomba no cenário
     }

     /**
      * Método responsável por sinalizar a bomba após explodida e ser excluida do ArrayList de bombas.
      */
     public synchronized void finalizandoBomba() {
          this.bombaViva = false;
          this.explodindo = false;
          this.explodida = true;
          this.jogador.liberarB(this); //Método que elimina a bomba da array
     }

     /**
      * Método que retorna se a bomba está ativa, porém não explodida ainda
      * @return
      */
     public boolean isBombaViva() {
          return bombaViva;
     }

     /**
      * Método que retorna se a bomba já está explodida.
      * @return
      */
     public synchronized  boolean isExplodida(){
          return this.explodida;
     }

     /**
      * Método que retorna true se o jogador que lançou esta bomba está nas coordenadas (y x) passados. False caso contrário
      * @param y
      * @param x
      * @return
      */
     public boolean jogadorPos(int y, int x) {
          if (this.jogador.matColuna == y && this.jogador.matLinha == x) {
               return true;
          }
          return false;
     }

     /**
      * Método que retorna true se o outro jogador ativo está nas coordenadas (argumentos) passados. False caso contrário
      * @param y
      * @param x
      * @return
      */
     public boolean outroJogadorPos(int y, int x) {
          if (this.outroJogador.matColuna == y && this.outroJogador.matLinha == x) {
               return true;
          }
          return false;
     }

     /**
      * Retorna o jogador que lançou esta bomba
      * @return
      */
     public synchronized Jogador bombaDeQualJogador(){
          return this.jogador;
     }

     /**
      * Retorna a posição da bomba na coordenada X
      * @return
      */
     public int posXBomba(){
          return this.posXBomb;
     }
     /**
      * Retorna a posição da bomba na coordenada Y
      * @return
      */
     public int posYBomba(){
          return this.posYBomb;
     }



}
