/**
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 *  Prof. Emerson Ribeiro de Mello (2011)
 *  mello@ifsc.edu.br
 */

/*
 * JavaBomberPrincipal.java
 *
 * Created on 25/10/2011, 14:25:56
 */
package principal;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.KeyEvent;
import javax.swing.JOptionPane;
import jogo.JogoTimer;

/**
 *
 * @author Emerson Ribeiro de Mello
 */
public class JavaBomber extends javax.swing.JFrame {

    private JogoTimer jogo;
    private JDialogConfig config2;
    public Teclado teclado;
    public boolean jogoRodando;
    public boolean jogoPausado;
    //0-Direita Jogador1
    //1-Esquerda Jogador1
    //2-Cima Jogador1
    //3-Baixo Jogador1
    //4-Atirar Jogador1
    //5-Direta Jogador2
    //6-Esquerda Jogador2
    //7-Cima Jogador2
    //8-Baixo Jogador2
    //9-Atirar Jogador2
    private int[] codTeclas = new int[10];

    /** Creates new form JavaBomberPrincipal */
    public JavaBomber() {
        initComponents();
        this.setLocationRelativeTo(null);

        this.jogo = new JogoTimer(this);

        jogo.setSize(jPTelaPrincipal.getSize());
        jogo.setPreferredSize(jPTelaPrincipal.getSize());
        jPTelaPrincipal.add(jogo, BorderLayout.PAGE_START);
        teclado = new Teclado();
        this.jPTelaPrincipal.addKeyListener(teclado);
        this.jogo.addKeyListener(teclado);
        this.jButton1.requestFocus();
        this.jogoRodando = false;

        this.codTeclas[0] = KeyEvent.VK_RIGHT;
        this.codTeclas[1] = KeyEvent.VK_LEFT;
        this.codTeclas[2] = KeyEvent.VK_UP;
        this.codTeclas[3] = KeyEvent.VK_DOWN;
        this.codTeclas[4] = KeyEvent.VK_SPACE;

        this.codTeclas[5] = KeyEvent.VK_D;
        this.codTeclas[6] = KeyEvent.VK_A;
        this.codTeclas[7] = KeyEvent.VK_W;
        this.codTeclas[8] = KeyEvent.VK_S;
        this.codTeclas[9] = KeyEvent.VK_1;




    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPInformacoes = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jPInfJog1 = new javax.swing.JPanel();
        jLIconeVida1Jog1 = new javax.swing.JLabel();
        jLIconeVida2Jog1 = new javax.swing.JLabel();
        jLIconeVida3Jog1 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldJogosGanhosJog1 = new javax.swing.JTextField();
        jPInfJog2 = new javax.swing.JPanel();
        jLIconeVida1Jog2 = new javax.swing.JLabel();
        jLIconeVida3Jog2 = new javax.swing.JLabel();
        jLIconeVida2Jog2 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldJogosGanhosJog2 = new javax.swing.JTextField();
        jButtonPause = new javax.swing.JButton();
        jButtonConf = new javax.swing.JButton();
        jPTelaPrincipal = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaStatus = new javax.swing.JTextArea();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItemNovoJogo = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuItemExit = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItemInstruções = new javax.swing.JMenuItem();
        jMenuItemSobre = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JavaBomber");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setResizable(false);
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });

        jButton1.setText("Start");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jPInfJog1.setBorder(javax.swing.BorderFactory.createTitledBorder("Jogador 1 Vidas"));

        jLIconeVida1Jog1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/azul.png"))); // NOI18N

        jLIconeVida2Jog1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/azul.png"))); // NOI18N

        jLIconeVida3Jog1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/azul.png"))); // NOI18N

        jLabel1.setText("Jogos ganhos:");

        jTextFieldJogosGanhosJog1.setEditable(false);
        jTextFieldJogosGanhosJog1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldJogosGanhosJog1.setForeground(new java.awt.Color(0, 102, 255));
        jTextFieldJogosGanhosJog1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldJogosGanhosJog1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        javax.swing.GroupLayout jPInfJog1Layout = new javax.swing.GroupLayout(jPInfJog1);
        jPInfJog1.setLayout(jPInfJog1Layout);
        jPInfJog1Layout.setHorizontalGroup(
            jPInfJog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPInfJog1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 157, Short.MAX_VALUE))
            .addGroup(jPInfJog1Layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(jLIconeVida1Jog1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLIconeVida2Jog1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLIconeVida3Jog1))
            .addGroup(jPInfJog1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTextFieldJogosGanhosJog1, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(130, Short.MAX_VALUE))
        );
        jPInfJog1Layout.setVerticalGroup(
            jPInfJog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPInfJog1Layout.createSequentialGroup()
                .addGroup(jPInfJog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLIconeVida1Jog1, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLIconeVida2Jog1, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLIconeVida3Jog1, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jTextFieldJogosGanhosJog1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jPInfJog2.setBorder(javax.swing.BorderFactory.createTitledBorder("Jogador 2 Vidas"));

        jLIconeVida1Jog2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/vermelho.png"))); // NOI18N

        jLIconeVida3Jog2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/vermelho.png"))); // NOI18N

        jLIconeVida2Jog2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/vermelho.png"))); // NOI18N

        jLabel2.setText("Jogos ganhos:");

        jTextFieldJogosGanhosJog2.setEditable(false);
        jTextFieldJogosGanhosJog2.setFont(new java.awt.Font("Tahoma", 1, 11));
        jTextFieldJogosGanhosJog2.setForeground(new java.awt.Color(255, 0, 0));
        jTextFieldJogosGanhosJog2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldJogosGanhosJog2.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        javax.swing.GroupLayout jPInfJog2Layout = new javax.swing.GroupLayout(jPInfJog2);
        jPInfJog2.setLayout(jPInfJog2Layout);
        jPInfJog2Layout.setHorizontalGroup(
            jPInfJog2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPInfJog2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPInfJog2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPInfJog2Layout.createSequentialGroup()
                        .addComponent(jLIconeVida1Jog2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLIconeVida2Jog2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLIconeVida3Jog2)
                        .addContainerGap())
                    .addGroup(jPInfJog2Layout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(111, 111, 111))
                    .addGroup(jPInfJog2Layout.createSequentialGroup()
                        .addComponent(jTextFieldJogosGanhosJog2, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        jPInfJog2Layout.setVerticalGroup(
            jPInfJog2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPInfJog2Layout.createSequentialGroup()
                .addGroup(jPInfJog2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLIconeVida1Jog2, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLIconeVida2Jog2, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLIconeVida3Jog2, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextFieldJogosGanhosJog2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jButtonPause.setText("Pause");
        jButtonPause.setFocusable(false);
        jButtonPause.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPauseActionPerformed(evt);
            }
        });

        jButtonConf.setText("Configurar Comandos");
        jButtonConf.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonConfActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPInformacoesLayout = new javax.swing.GroupLayout(jPInformacoes);
        jPInformacoes.setLayout(jPInformacoesLayout);
        jPInformacoesLayout.setHorizontalGroup(
            jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPInformacoesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jButtonConf, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPInfJog2, javax.swing.GroupLayout.Alignment.LEADING, 0, 181, Short.MAX_VALUE)
                    .addComponent(jPInfJog1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPInformacoesLayout.createSequentialGroup()
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonPause)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPInformacoesLayout.setVerticalGroup(
            jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPInformacoesLayout.createSequentialGroup()
                .addGroup(jPInformacoesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonPause, javax.swing.GroupLayout.DEFAULT_SIZE, 41, Short.MAX_VALUE)
                    .addComponent(jButton1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 41, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPInfJog1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPInfJog2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonConf)
                .addContainerGap())
        );

        jPTelaPrincipal.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jPTelaPrincipal.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jPTelaPrincipalFocusLost(evt);
            }
        });
        jPTelaPrincipal.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jPTelaPrincipalKeyPressed(evt);
            }
        });
        jPTelaPrincipal.setLayout(new java.awt.BorderLayout());

        jTextAreaStatus.setColumns(20);
        jTextAreaStatus.setEditable(false);
        jTextAreaStatus.setRows(5);
        jTextAreaStatus.setFocusable(false);
        jScrollPane1.setViewportView(jTextAreaStatus);

        jMenu1.setText("Jogo");

        jMenuItemNovoJogo.setText("Novo jogo");
        jMenuItemNovoJogo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemNovoJogoActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemNovoJogo);
        jMenu1.add(jSeparator1);

        jMenuItemExit.setText("Sair");
        jMenuItemExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExitActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemExit);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Ajuda");

        jMenuItemInstruções.setText("Instruções");
        jMenuItemInstruções.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemInstruçõesActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItemInstruções);

        jMenuItemSobre.setText("Sobre");
        jMenuItemSobre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSobreActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItemSobre);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jScrollPane1)
                    .addComponent(jPTelaPrincipal, javax.swing.GroupLayout.DEFAULT_SIZE, 677, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPInformacoes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPTelaPrincipal, javax.swing.GroupLayout.PREFERRED_SIZE, 434, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(11, 11, 11)
                        .addComponent(jPInformacoes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jPTelaPrincipalKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jPTelaPrincipalKeyPressed
    }//GEN-LAST:event_jPTelaPrincipalKeyPressed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (jogoRodando == false) {
            this.jogo.comecaOJogo();
            this.jogoRodando = true;
            // dando foco na area do jogo
            this.jPTelaPrincipal.requestFocus(); // para tirar o foco de botão e ir pra tela do jogo, para poder usar o teclado
        } else {
            this.jogo.escreverNoStatus("Jogo já em andamento...");
        }


    }//GEN-LAST:event_jButton1ActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
       
    }//GEN-LAST:event_formWindowGainedFocus

    private void jPTelaPrincipalFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jPTelaPrincipalFocusLost
       
    }//GEN-LAST:event_jPTelaPrincipalFocusLost

private void jMenuItemNovoJogoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemNovoJogoActionPerformed
    if (jogoRodando == false) {
        this.jogo.comecaOJogo();
        this.jogoRodando = true;
        // dando foco na area do jogo
        this.jPTelaPrincipal.requestFocus(); // para tirar o foco de botão e ir pra tela do jogo, para poder usar o teclado
    } else {
    }
}//GEN-LAST:event_jMenuItemNovoJogoActionPerformed

private void jButtonPauseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPauseActionPerformed
    if (this.jogoRodando == true) {
        if (this.jogoPausado == false) {
            this.jogo.pausarJogo();
            this.jogoPausado = true;
            this.jButton1.setEnabled(false);
            this.jButtonPause.setText("Continua");
            this.jogo.escreverNoStatus("Jogo Pausado!!");
        } else {
            this.jogo.despausarJogo();
            this.jogoPausado = false;
            this.jButton1.setEnabled(true);
            this.jButtonPause.setText("Pause");
            this.jogo.escreverNoStatus("Continuando jogo...");
            this.jPTelaPrincipal.requestFocus();
        }
    } else {
        this.jogo.escreverNoStatus("Não é possível pausar um jogo que não tenha sido iniciado");
    }


}//GEN-LAST:event_jButtonPauseActionPerformed

private void jMenuItemExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExitActionPerformed
    System.exit(0);
}//GEN-LAST:event_jMenuItemExitActionPerformed

private void jMenuItemInstruçõesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemInstruçõesActionPerformed
    JOptionPane.showMessageDialog(this, "Objetivo do jogo:\n\nEliminar o outro jogador através do lançamento de suas bombas.\n\nCada personagem tem 3 vidas... etc etc etc");
}//GEN-LAST:event_jMenuItemInstruçõesActionPerformed

private void jMenuItemSobreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSobreActionPerformed
    JOptionPane.showMessageDialog(this, " Este programa é software livre; você pode redistribuí-lo e/ou\n"+
   "modificá-lo sob os termos da Licença Pública Geral GNU, conforme\n"+
   "publicada pela Free Software Foundation; tanto a versão 2 da\n"+
   "Licença como (a seu critério) qualquer versão mais nova.\n\n"+
 
   "Este programa é distribuído na expectativa de ser útil, mas SEM\n"+
   "QUALQUER GARANTIA; sem mesmo a garantia implícita de\n"+
   "COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM\n"+
   "PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais\n"+
   "detalhes.\n\n"+
 
   "Você deve ter recebido uma cópia da Licença Pública Geral GNU\n");
   //junto com este programa; se não, escreva para a Free Software
   //Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   //02111-1307, USA.
 
   ///Prof. Emerson Ribeiro de Mello (2011)
   //mello@ifsc.edu.br)";
}//GEN-LAST:event_jMenuItemSobreActionPerformed

private void jButtonConfActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonConfActionPerformed
    if (this.jogoRodando == true) {
        this.jogo.pausarJogo();
        this.jogoPausado = true;
        this.jButton1.setEnabled(false);
        this.jButtonPause.setText("Continua");
        this.jogo.escreverNoStatus("Jogo Pausado!!");
        this.jogo.setIgnoreRepaint(false);
        this.config2 = new JDialogConfig(this, true);
        this.config2.setVisible(true);
        this.config2.requestFocus();
         
    } else {
        this.config2 = new JDialogConfig(this, true);
        this.config2.setVisible(true);
        this.config2.requestFocus();
    }
}//GEN-LAST:event_jButtonConfActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JavaBomber.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new JavaBomber().setVisible(true);
            }
        });
    }

    public int getJog1Bomb() {
        return codTeclas[4];
    }

    public void setJog1Bomb(int jog1Bomb) {
        this.codTeclas[4] = jog1Bomb;
    }

    public int getJog1Down() {
        return codTeclas[3];
    }

    public void setJog1Down(int jog1Down) {
        this.codTeclas[3] = jog1Down;
    }

    public int getJog1Left() {
        return codTeclas[1];
    }

    public void setJog1Left(int jog1Left) {
        this.codTeclas[1] = jog1Left;
    }

    public int getJog1Right() {
        return codTeclas[0];
    }

    public void setJog1Right(int jog1Right) {
        this.codTeclas[0] = jog1Right;
    }

    public int getJog1Up() {
        return codTeclas[2];
    }

    public void setJog1Up(int jog1Up) {
        this.codTeclas[2] = jog1Up;
    }

    public int getJog2Bomb() {
        return codTeclas[9];
    }

    public void setJog2Bomb(int jog2Bomb) {
        this.codTeclas[9] = jog2Bomb;
    }

    public int getJog2Down() {
        return codTeclas[8];
    }

    public void setJog2Down(int jog2Down) {
        this.codTeclas[8] = jog2Down;
    }

    public int getJog2Left() {
        return codTeclas[6];
    }

    public void setJog2Left(int jog2Left) {
        this.codTeclas[6] = jog2Left;
    }

    public int getJog2Right() {
        return codTeclas[5];
    }

    public void setJog2Right(int jog2Right) {
        this.codTeclas[5] = jog2Right;
    }

    public int getJog2Up() {
        return codTeclas[7];
    }

    public void setJog2Up(int jog2Up) {
        this.codTeclas[7] = jog2Up;
    }

    public int[] getCodTeclas() {
        return codTeclas;
    }

    public void setCodTeclas(int[] codTeclas) {
        this.codTeclas = codTeclas;
    }

    public JogoTimer getJogo() {
        return jogo;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonConf;
    private javax.swing.JButton jButtonPause;
    public javax.swing.JLabel jLIconeVida1Jog1;
    public javax.swing.JLabel jLIconeVida1Jog2;
    public javax.swing.JLabel jLIconeVida2Jog1;
    public javax.swing.JLabel jLIconeVida2Jog2;
    public javax.swing.JLabel jLIconeVida3Jog1;
    public javax.swing.JLabel jLIconeVida3Jog2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItemExit;
    private javax.swing.JMenuItem jMenuItemInstruções;
    private javax.swing.JMenuItem jMenuItemNovoJogo;
    private javax.swing.JMenuItem jMenuItemSobre;
    private javax.swing.JPanel jPInfJog1;
    private javax.swing.JPanel jPInfJog2;
    private javax.swing.JPanel jPInformacoes;
    private javax.swing.JPanel jPTelaPrincipal;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    public javax.swing.JTextArea jTextAreaStatus;
    public javax.swing.JTextField jTextFieldJogosGanhosJog1;
    public javax.swing.JTextField jTextFieldJogosGanhosJog2;
    // End of variables declaration//GEN-END:variables
}
